#
# spec file for package rubygem-ruby-dbus
#
# Copyright (c) 2025 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


#
# This file was generated with a gem2rpm.yml and not just plain gem2rpm.
# All sections marked as MANUAL, license headers, summaries and descriptions
# can be maintained in that file. Please consult this file before editing any
# of those fields
#

Name:           rubygem-ruby-dbus
Version:        0.24.0
Release:        1.1
%define mod_name ruby-dbus
%define mod_full_name %{mod_name}-%{version}
# MANUAL
BuildRequires:  %{rubygem nokogiri >= 1.12}
BuildRequires:  %{rubygem packaging_rake_tasks}
BuildRequires:  %{rubygem rake}
BuildRequires:  %{rubygem rspec >= 3.9}
BuildRequires:  dbus-1
BuildRequires:  dbus-1-daemon
BuildRequires:  netcfg libnss_usrfiles2
# /MANUAL
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  %{ruby >= 2.4.0}
BuildRequires:  %{rubygem gem2rpm}
BuildRequires:  ruby-macros >= 5
URL:            https://github.com/mvidner/ruby-dbus
Source:         https://rubygems.org/gems/%{mod_full_name}.gem
Source1:        gem2rpm.yml
Summary:        Ruby module for interaction with D-Bus
License:        LGPL-2.1-or-later
Group:          Development/Languages/Ruby

%description
Pure Ruby module for interaction with D-Bus IPC system.

%prep

%build

%install
%gem_install \
  --doc-files="COPYING NEWS.md README.md" \
  -f

# MANUAL
%check
(pushd %{buildroot}%{gem_base}/gems/%{mod_full_name} && rake test)
#/ MANUAL

%gem_packages

%changelog
* Thu Jan  2 2025 Martin Vidner <mvidner@suse.com>
- 0.24.0
  Bug fixes:
  * Adapted for Ruby 3.4, which uses a single quote instead of a backtick
  in exceptions (gh#mvidner/ruby-dbus#145, by Mamoru TASAKA).
* Tue Oct  3 2023 Martin Vidner <mvidner@suse.com>
- 0.23.1
  API:
  * Add DBus::Object.dbus_reader_attr_accessor to declare a common use case
  with a single call (gh#mvidner/ruby-dbus#140).
  * BusConnection#request_name defaults to the simple use case: single owner
  without queuing, failing fast; documented the complex use cases.
* Fri Jun 23 2023 Martin Vidner <mvidner@suse.com>
- 0.23.0.beta2
  License:
  * clarified to be LGPL-2.1-or-later
  API:
  * DBus::Object#object_server replaces @service (which still works) and the short-lived
  @connection
  * ObjectServer#export will raise if the path is already taken by an object
  * ObjectServer#unexport now also accepts an object path
  * Connection#object_server can export objects even without requesting any
  service name (gh#mvidner/ruby-dbus#49, in beta1 already).
  * Add PeerConnection for connections without a bus, useful for PulseAudio.
  Fix listening for signals there (gh#mvidner/ruby-dbus##44).
  * Moved from Connection to BusConnection: #unique_name, #proxy, #service.
  Call send_hello in BusConnection#initialize already.
  Bug fixes:
  * Fixed a refactoring crasher bug in ProxyService#introspect (oops).
  * Fix crash on #unexport of /child_of_root or even /
* Mon Jun  5 2023 Martin Vidner <mvidner@suse.com>
- 0.23.0.beta1
  Bug fixes:
  * A service can now have more than one name (gh#mvidner/ruby-dbus#69).
    Connection#request_service is deprecated in favor of Connection#object_server
    and BusConnection#request_name
  API:
  * Remove Service, splitting it into ProxyService and ObjectServer
  * Split off BusConnection from Connection
* Wed May 17 2023 Martin Vidner <mvidner@suse.com>
- 0.22.1
  Bug fixes:
  * Fix OBS building by disabling IPv6 tests, gh#mvidner/ruby-dbus#134.
* Mon May  8 2023 Martin Vidner <mvidner@suse.com>
- 0.22.0
  Features:
  * Enable using nokogiri without rexml (by Dominik Andreas Schorpp,
  gh#mvidner/ruby-dbus#132)
  Bug fixes:
  * Respect DBUS_SYSTEM_BUS_ADDRESS environment variable.
  Other:
  * For NameRequestError, mention who is the other owner.
  * Session bus autolaunch still does not work, but: don't try launchd except
  on macOS, and improve the error message.
  * examples/gdbus split off to its own repository
* Sat Apr  8 2023 Martin Vidner <mvidner@suse.com>
- 0.21.0
  Features:
  * Respect env RUBY_DBUS_ENDIANNESS=B (or =l) for outgoing messages.
  Bug fixes:
  * Reduce socket buffer allocations (gh#mvidner/ruby-dbus#129).
  * Message#marshall speedup: don't marshall the body twice.
* Tue Mar 21 2023 Martin Vidner <mvidner@suse.com>
- 0.20.0
  Features:
  * For EXTERNAL authentication, try also without the user id, to work with
  containers (gh#mvidner/ruby-dbus#126).
  * Thread safety, as long as the non-main threads only send signals.
* Wed Jan 18 2023 Martin Vidner <mvidner@suse.com>
- 0.19.0
  API:
  * Added a ObjectManager mix-in to implement the service-side
  ObjectManager interface.
  Bug fixes:
  * dbus_attr_accessor and friends validate the signature
  * (gh#mvidner/ruby-dbus#120).
  * Declare the Introspectable interface in exported
  * objects (gh#mvidner/ruby-dbus#99).
  * Do reply with an error when calling a nonexisting object
  with an existing path prefix (gh#mvidner/ruby-dbus#121).
* Wed Jul 13 2022 Martin Vidner <mvidner@suse.com>
- 0.18.1
  Most important change since 0.17.0:
  * Introduced DBus::Data classes, use them in Properties.Get,
  Properties.GetAll to return correct types as declared
  (gh#mvidner/ruby-dbus#97).
* Tue Jun 21 2022 Martin Vidner <mvidner@suse.com>
- 0.18.0.beta8
  Bug fixes:
  * Introduced Object#dbus_properties_changed to send correctly typed property
  values (gh#mvidner/ruby-dbus#115). Avoid calling PropertiesChanged directly
  as it will guess the types.
  * Fix Object.dbus_reader to work with attr_accessor and automatically produce
  dbus_properties_changed for properties that are read-write at
  implementation side and read-only at D-Bus side (gh#mvidner/ruby-dbus#96)
  API:
  * Service side `emits_changed_signal` to control emission of
  PropertiesChanged: can be assigned within `dbus_interface` or as an option
  when declaring properties (gh#mvidner/ruby-dbus#117).
* Sun May 29 2022 Martin Vidner <mvidner@suse.com>
- 0.18.0.beta7
  API:
  * DBus.variant(type, value) is deprecated in favor of
  Data::Variant.new(value, member_type:)
  Bug fixes:
  * Client-side properties: When calling Properties.Set in
  ProxyObjectInterface#[]=, use the correct type (gh#mvidner/ruby-dbus#108).
* Wed May 25 2022 Martin Vidner <mvidner@suse.com>
- 0.18.0.beta6
  API:
  * Data::Base#value returns plain Ruby types;
  Data::Container#exact_value contains Data::Base (gh#mvidner/ruby-dbus#114).
  * Data::Base#initialize and .from_typed allow plain or exact values, validate
  argument types.
  * Implement #== (converting) and #eql? (strict) for Data::Base and DBus::Type.
* Wed Apr 27 2022 Martin Vidner <mvidner@suse.com>
- 0.18.0.beta5
  API
  * DBus::Type instances are frozen.
  * Data::Container classes (Array, Struct, DictEntry, but not Variant)
  constructors (#initialize, .from_items, .from_typed) changed to have
  a *type* argument instead of *member_type* or *member_types*.
  * Added type factories
  * Type::Array[type]
  * Type::Hash[key_type, value_type]
  * Type::Struct[type1, type2...]
  Bug fixes:
  * Properties containing Variants would return them doubly wrapped
  (gh#mvidner/ruby-dbus#111).
* Thu Apr 21 2022 Martin Vidner <mvidner@suse.com>
- 0.18.0.beta4
  Bug fixes:
  * Service-side properties: Fix Properties.Get, Properties.GetAll
  for properties that contain arrays, on other than outermost
  level (gh#mvidner/ruby-dbus#109).
  * Sending variants: fixed make_variant to correctly guess the
  signature for UInt64 and number-keyed hashes/dictionaries.
* Sun Apr 10 2022 Martin Vidner <mvidner@suse.com>
- 0.18.0.beta3
  Bug fixes:
  * Service-side properties: Fix Properties.Get, Properties.GetAll
  for Array, Dict, and Variant types (gh#mvidner/ruby-dbus#105).
* Mon Apr  4 2022 Martin Vidner <mvidner@suse.com>
- 0.18.0.beta2
  API:
  * Renamed the DBus::Type::Type class to DBus::Type
  (which was previously a module).
  * Introduced DBus::Data classes, use them in Properties.Get,
  Properties.GetAll to return correct types as declared (still
  gh#mvidner/ruby-dbus#97).
  Bug fixes:
  * Signature validation: Ensure DBus.type produces a valid Type
  * Detect more malformed messages: non-NUL padding bytes, variants with
  multiple or no value.
  * Added thorough tests (spec/data/marshall.yaml) to detect nearly all
  invalid data at unmarshalling time.
* Thu Feb 24 2022 Martin Vidner <mvidner@suse.com>
- 0.18.0.beta1
  API:
  * D-Bus structs have been passed as Ruby arrays. Now these arrays
  are frozen.
  * Ruby structs can be used as D-Bus structs.
  Bug fixes:
  * Returning the value for o.fd.DBus.Properties.Get, use the
  specific property signature, not the generic Variant
  (gh#mvidner/ruby-dbus#97).
* Fri Feb 11 2022 Martin Vidner <mvidner@suse.com>
- 0.17.0
  API:
  * Export properties with `dbus_attr_accessor`, `dbus_reader` etc.
  (gh#mvidner/ruby-dbus#86).
  Bug fixes:
  * Depend on rexml which is separate since Ruby 3.0
  (gh#mvidner/ruby-dbus#87, by Toshiaki Asai).
  Nokogiri is faster but bigger so it remains optional.
  * Fix connection in case ~/.dbus-keyrings has multiple cookies, showing
  as "Oops: undefined method `zero?' for nil:NilClass".
  * Add the missing name to the root introspection node.
* Tue Oct 15 2019 Martin Vidner <mvidner@suse.com>
- 0.16.0
  API:
  * An invalid service name or an invalid object path will raise
  instead of being sent to the bus. The bus would then drop the
  connection, producing EOFError here (gh#mvidner/ruby-dbus#80).
* Mon Apr 30 2018 mvidner@suse.com
- 0.15.0
  API:
  * Accessing an unknown interface will raise instead of
  returning nil (gh#mvidner/ruby-dbus#74).
  Bug fixes:
  * Fixed a conflict with activesupport 5.2 (gh#mvidner/ruby-dbus#71)
* Fri Jan  5 2018 mvidner@suse.com
- 0.14.1
  Bug fixes:
  * Allow registering signal handlers while a signal is being handled
  (gh#mvidner/ruby-dbus#70, Jan Biniok).
* Fri Oct 13 2017 mvidner@suse.com
- 0.14.0
  Bug fixes:
  * Sending 16-bit signed integers ("n") did not work at all
  (gh#mvidner/ruby-dbus#68).
  Requirements:
  * Stopped supporting ruby 2.0.0, because of Nokogiri.
* Wed Sep 21 2016 mvidner@suse.com
- 0.13.0
  Bug fixes:
  * It is no longer required to explicitly call ProxyObject#introspect,
  it will be done automatically once (gh#mvidner/ruby-dbus#28).
* Mon Sep 12 2016 mvidner@suse.com
- 0.12.0
  API:
  * Added proxy objects whose methods return single values instead of arrays
  (use Service#[] instead of Service#object; Issue#30).
  Requirements:
  * Require ruby 2.0.0, stopped supporting 1.9.3.
* Sun Sep 11 2016 mvidner@suse.com
- 0.11.2:
  Bug fixes:
  * Fixed reading a quoted session bus address, as written by dbus-1.10.10
  (Yasuhiro Asaka)
* Thu May 12 2016 mvidner@suse.com
- 0.11.1
  Bug fixes:
  * Fix default path finding on FreeBSD (Greg)
  * Service#unexport fixed to really return the unexported object
  Requirements:
  * made tests compatible with RSpec 3
* Thu Oct 16 2014 coolo@suse.com
- adapt to new rubygem packaging
* Mon Feb 17 2014 mvidner@suse.com
- 0.11.0
  API:
  * Connection: split off MessageQueue, marked other methods as private.
  Requirements:
  * converted tests to RSpec, rather mechanically for now
* Fri Jan 10 2014 mvidner@suse.com
- 0.10.0
  Bug fixes:
  * fixed "Interfaces added with singleton_class.instance_eval aren't
  exported" (Issue#22, by miaoufkirsh)
  Requirements:
  * Require ruby 1.9.3, stopped supporting 1.8.7.
* Thu Jan  2 2014 mvidner@suse.com
- 0.9.3
  Bug fixes:
  * re-added COPYING, NEWS, README.md to the gem (Issue#47,
  by Cédric Boutillier)
  Packaging:
  * use packaging_rake_tasks
* Wed May  8 2013 mvidner@suse.com
- 0.9.2
  Features:
  * Ruby strings can be passed where byte arrays ("ay") are expected
  (Issue#40, by Jesper B. Rosenkilde)
  Bug fixes:
  * Fixed accessing ModemManager properties (Issue#41, reported
  by Ernest Bursa). MM introspection produces two elements
  for a single interface; merge them.
* Mon Apr 29 2013 mvidner@suse.cz
- fixed build: unspecify port and address family
* Tue Apr 23 2013 mvidner@suse.cz
- 0.9.1
  Bug fixes:
  * Prefer /etc/machine-id to /var/lib/dbus/machine-id
  when DBUS_SESSION_BUS_ADDRESS is unset (Issue#39, by WU Jun).
- BTW netcfg did not help. Using 127.0.0.1 in upstream now.
* Tue Apr 16 2013 mvidner@suse.cz
- BuildRequire netcfg to fix tests failing with
  'Failed to lookup host/port: "localhost:0"'
* Tue Nov  6 2012 mvidner@suse.cz
- 0.9.0
  Features:
  * When calling methods, the interface can be left unspecified if unambiguous
  (Damiano Stoffie)
  * YARD documentation, Reference.md
  Bug fixes:
  * Introspection attribute "direction" can be omitted
  as allowed by the specification (Noah Meyerhans).
  * ProxyObjectInterface#on_signal no longer needs the "bus" parameter
  (Issue#31, by Damiano Stoffie)
* Thu Sep 20 2012 mvidner@suse.cz
- 0.8.0
  Features:
  * Add Anonymous authentication (Issue#27, by Walter Brebels).
  * Use Nokogiri for XML parsing when available (Issue#24, by Geoff Youngs).
  Bug fixes:
  * Use SCM_CREDS authentication only on FreeBSD, not on OpenBSD (Issue#21,
  reported by Adde Nilsson).
  * Recognize signature "h" (UNIX_FD) used eg. by Upstart (Issue#23,
  by Bernd Ahlers).
  * Find the session bus also via launchd, on OS X (Issue#20, reported
  by Paul Sturgess).
* Thu Apr  5 2012 mvidner@suse.cz
- 0.7.2, a bugfix release
  * Fixed "undefined local variable or method `continue'" in
  DBus::Main#run when a service becomes idle (by Ravil Bayramgalin)
* Wed Apr  4 2012 mvidner@suse.cz
- 0.7.1, a bugfix release
  * Fixed calling asynchronous methods on the default interface (Issue#13,
  by Eugene Korbut).
  * Fixed Main#quit to really quit the loop (by Josef Reidinger)
  * Unbundled files from Active Support (by Bohuslav Kabrda)
* Mon Feb 13 2012 coolo@suse.com
- patch license to follow spdx.org standard
* Mon Jul 25 2011 mvidner@suse.cz
- 0.7.0, a bugfix release
  * Added ASystemBus and ASessionBus, non-singletons useful in tests
  and threads.
  * Fixed handling of multibyte strings (Issue#8, by Takayuki YAMAGUCHI).
  * Allow reopening of a dbus_interface declaration (Issue#9, by T. YAMAGUCHI).
  * Fixed ruby-1.9.2 compatibility again (Issue#12).
  * Fixed authentication on BSD (Issue#11, by Jonathan Walker).
  * Fixed exiting a nested event loop for synchronous calls
  (reported by Timo Warns).
  * Fixed introspection calls leaking reply handlers.
  * "rake test" now works, doing what was called "rake env:test"
- updated the spec from a current template to build doc and
  testsuite subpackages
* Fri Dec 10 2010 mvidner@suse.cz
- 0.6.0
  * Clients can access properties conveniently (Ticket#28).
  * Service won't crash whan handling an unknown method or interface (Ticket#31).
  * Don't send an invalid error name when it originates from a NameError.
* Wed Nov 10 2010 mvidner@suse.cz
- really Provide+Obsolete ruby-dbus.rpm.
* Sun Nov  7 2010 mvidner@suse.cz
- 0.5.0
  * Better binding of Ruby Exceptions to D-Bus Errors.
  * Converted the package to a Gem (Issue#6).
  * Converted the tutorial from Webgen to Markdown.
  * Don't pass file descriptors to subprocesses.
  * Fixed InterfaceElement::validate_name (Ticket#38, by Herwin Weststrate).
  * Fixed a typo in InvalidDestinationName description (Ticket#40).
- rubygem-ruby-dbus.rpm obsoletes ruby-dbus.rpm
* Fri Aug 20 2010 mvidner@suse.cz
- 0.4.0
  * TCP transport (by pangdudu)
  * Enabled test code coverage report (rcov)
  * Classes should not share all interfaces (Ticket#36/Issue#5)
  * Ruby 1.9 compatibility (Ticket#37, by Myra Nelson)
- require rake for building
* Thu Jul 22 2010 mvidner@suse.cz
- 0.3.1
  * Many on_signal could cause DBus.Error.LimitsExceeded bnc#617350).
  Don't add a match rule that already exists, enable removing match
  rules. Now only one handler for a rule is called (but it is possible
  for one signal to match more rules). This reverts the half-fix done
  to fix Issue#3
  * Re-added InterfaceElement#add_param for compatibility.
  * Handle more ways which tell us that a bus connection has died.
* Sun Mar 28 2010 mvidner@novell.com
- 0.3.0
  * Automatic signature inference for variants.
  * Introduced FormalParameter where a plain pair had been used.
  * Fixed "undefined method `get_node' for nil:NilClass"
  on Ubuntu Karmic (Ticket#34).
  * Get the session bus address even if unset in ENV (Issue#4).
  * Avoid needless DBus::IncompleteBufferException (Ticket#33).
  * Don't ignore DBus Errors in request_service, raise them (Ticket#32).
- took the patches upstream
* Tue Feb 23 2010 kkaempf@novell.com
- bump version to 0.2.12.1
* Fri Feb 19 2010 kkaempf@novell.com
- add the name in error to InvalidMethodName
- make the signal dispatcher call all handlers (bnc#580935)
- don't process an empty buffer
* Thu Feb  4 2010 kkaempf@novell.com
- Define Integer.ord for Ruby < 1.8.7
* Sun Jan 24 2010 mvidner@suse.cz
- 0.2.12
  * Fixed a long-standing bug where a service activated by the bus
    would fail with "undefined method get_node' for nil:NilClass"
    (Tickets#25 and #29).
* Thu Nov 12 2009 mvidner@suse.cz
- 0.2.11
  * Added DBus::Service#unexport (da1l6).
  * Return org.freedesktop.DBus.Error.UnknownObject instead of crashing
  (Ticket#31).
  * Rescue exceptions in dbus_methods and reply with DBus errors instead of
  crashing (da1l6).
  * Better exception messages when sending nil, or mismatched structs.
  * Call mktemp without --tmpdir, to build on older distros.
- Undo the misguided BuildRequires dbus-1-devel
* Sat Sep 26 2009 kkaempf@suse.de
- BuildRequires dbus-1-devel
* Thu Sep 10 2009 mvidner@suse.cz
- DBus::Service.exists? fixed (Murat Demirten).
- Ruby 1.9 fixes (Jedediah Smith).
- Fixed an endless sleep in DBus::Main.run (bnc#537401).
- Added details to PacketMarshaller exceptions (bnc#538050).
- 0.2.10
* Wed Aug 26 2009 mvidner@suse.cz
- Released a new tarball. New changes:
  - Added DBus::Main.quit.
  - Mention the DBus interface in a NameError for an unknown method.
  - Fixed ruby-1.9 "warning: default `to_a' will be obsolete".
- 0.2.9
* Tue Jul  7 2009 mvidner@suse.cz
- added patch from http://github.com/mvidner/ruby-dbus, since r160
  to yesterday, obsoleting the Jun 18 patch.
  - Fixed passing an array through a variant.
  - Fixed marshalling "av" (Ticket #30).
  - Fixed variant alignment (Ticket #27).
- 0.2.1.3
* Mon Jun 29 2009 jreidinger@suse.cz
- increase version to 0.2.1.2 to use this package instead from one
  from another repository that just rebuild due to dependencies
- 0.2.1.2
* Thu Jun 18 2009 jreidinger@suse.cz
- add patch that prevent crash during  receiving array of variants
* Mon Sep  8 2008 mrueckert@suse.de
- added ruby-dbus-0.2.1_to_trunk.patch:
  pull in latest changes from trunk
* Mon Sep  8 2008 mrueckert@suse.de
- initial package of version 0.2.1
